import { ModuleDescription, ModuleData, AdventureImage, CaptionImage } from "./IAdventure";
import { ModuleScene } from "./ModuleScene";
import { PdfData } from "../parse";
import { PageLayoutEmitFunction, PageLayout } from "./PageLayouts";
import * as EC from './extinctioncurse';
import { sentenceCase } from "./core";

const adventureModule : ModuleDescription = {
    prefix: "extinction-curse6",
    fullName: "Extinction Curse - The Apocalypse Prophet",
    detect: (pdf: PdfData) => {
        return pdf.textDetails.some(t => t.text.trim() == 'EXTINCTION CURSE: THE APOCALYPSE PROPHET' && t.fontId == 'Gin-Regular:12');
    },
    extractDetails: EC.extractDetails,
    detectPageLayout: EC.detectPageLayout,
    pages: [
        // chapter 1
        new EC.ChapterHeadingPageLayout(6),
        new EC.RightSingleColumnWithSidebar(7),
        new EC.LeftTwoColumnWithLeftCutout(8, 236),
        new EC.RightTwoColumn(9),
        new EC.LeftTwoColumn(10),
        new EC.RightTwoColumnWithRightCutout(11, 315),
        new EC.LeftTwoColumnWithMap(12, 340),
        new EC.RightTwoColumn(13),
        new EC.LeftTwoColumn(14),
        new EC.RightTwoColumn(15),
        new EC.LeftTwoColumn(16),
        new EC.RightTwoColumn(17),
        new EC.LeftTwoColumn(18),
        new EC.RightTwoColumn(19),
        new EC.LeftTwoColumn(20),
        new EC.RightTwoColumn(21),
        new EC.LeftTwoColumn(22),
        new EC.RightTwoColumn(23),
        new EC.LeftTwoColumn(24),
        new EC.RightTwoColumn(25),
        new EC.LeftTwoColumn(26),
        new EC.RightTwoColumn(27),

        // chapter 2
        new EC.ChapterHeadingPageLayout(28),
        new EC.RightSingleColumnWithSidebar(29),
        new EC.LeftTwoColumnWithMap(30, 330),
        new EC.RightTwoColumn(31),
        new EC.LeftTwoColumn(32),
        new EC.RightTwoColumn(33),
        new EC.LeftTwoColumnWithMap(34, 510),
        new EC.RightTwoColumn(35),
        new EC.LeftTwoColumn(36),
        new EC.RightTwoColumn(37),
        new EC.LeftTwoColumn(38),
        new EC.RightTwoColumnWithRightCutout(39, 420),
        new EC.LeftTwoColumn(40),
        new EC.RightTwoColumn(41),
        new EC.LeftTwoColumn(42),
        new EC.RightTwoColumn(43),
        new EC.LeftTwoColumn(44),
        new EC.RightTwoColumn(45),
        new EC.LeftTwoColumn(46),
        new EC.RightTwoColumn(47),

        // chapter 3
        new EC.ChapterHeadingPageLayout(48),
        new EC.RightSingleColumnWithSidebar(49),
        new EC.LeftTwoColumn(50),
        new EC.RightTwoColumn(51),
        new EC.LeftTwoColumn(52),
        new EC.RightTwoColumn(53),
        new EC.LeftTwoColumn(54),
        new EC.RightTwoColumn(55),
        new EC.LeftTwoColumn(56),
        new EC.RightTwoColumn(57),
        new EC.LeftTwoColumn(58),
        new EC.RightTwoColumn(59),
        
        // appendix 1
        new EC.RightChapterHeadingPageLayout(61),
        new EC.LeftTwoColumnWithMap(62, 330),
        new EC.RightTwoColumnWithRightCutout(63, 245),
        new EC.LeftTwoColumn(64),
        new EC.RightTwoColumn(65),
        
        // appendix 2
        new EC.RightChapterHeadingPageLayout(67),
        new EC.LeftTwoColumn(68),
        new EC.RightTwoColumn(69),
        new EC.LeftTwoColumn(70),
        new EC.RightTwoColumn(71),
        
        // adventure toolbox
        new EC.RightChapterHeadingPageLayout(73),
        new EC.LeftTwoColumn(74),
        new EC.RightTwoColumn(75),
        new EC.LeftTwoColumn(76),
        new EC.RightTwoColumn(77),
        new EC.LeftTwoColumn(78),
        new EC.RightSingleColumnWithSidebar(79),
        new EC.LeftSingleColumnWithSidebar(80),
        new EC.RightSingleColumnWithSidebar(81),
        new EC.LeftSingleColumnWithSidebar(82),
        new EC.RightSingleColumnWithSidebar(83),
        new EC.LeftSingleColumnWithSidebar(84),
        new EC.RightSingleColumnWithSidebar(85),
        new EC.LeftSingleColumnWithSidebar(86),
        new EC.RightSingleColumnWithSidebar(87),
        new EC.ChapterHeadingPageLayout(88),
        new EC.RightTwoColumn(89),
        new EC.ChapterHeadingPageLayout(90),
        new EC.RightTwoColumn(91),
        new EC.ChapterHeadingPageLayout(92),
        new EC.RightTwoColumn(93),        
    ],
    scenes: [
        new ModuleScene({
            name: 'map1',
            nameInfo: { x: 213.1201, y: 694.6681 },
            nameFn: name => sentenceCase(name),
            page: 9, width: 626, height: 452,
            imageLeft: 7, imageRight: 608, imageCols: 28,
            imageTop: 21, imageBottom: 428, imageRows: 19,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map2',
            nameInfo: { x: 27, y: 750.8362 },
            nameFn: name => sentenceCase(name),
            page: 12, width: 1259, height: 880,
            imageLeft: 21, imageRight: 1234, imageCols: 32,
            imageTop: 22, imageBottom: 855, imageRows: 22,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map3',
            nameInfo: { x: 107, y: 274.6681 },
            nameFn: name => sentenceCase(name),
            page: 22, width: 626, height: 455,
            imageLeft: 18, imageRight: 604, imageCols: 27,
            imageTop: 17, imageBottom: 450, imageRows: 20,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map4',
            nameInfo: { x: 244.6201, y: 275.1686 },
            nameFn: name => sentenceCase(name),
            page: 24, width: 626, height: 453,
            imageLeft: 3, imageRight: 604, imageCols: 28,
            imageTop: 6, imageBottom: 434, imageRows: 20,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map5',
            nameInfo: { x: 244.6201, y: 275.1686 },
            nameFn: name => sentenceCase(name),
            page: 26, width: 626, height: 453,
            imageLeft: 22, imageRight: 603, imageCols: 27,
            imageTop: 23, imageBottom: 433, imageRows: 19,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map6',
            nameInfo: { x: 31, y: 756.8362 },
            nameFn: name => sentenceCase(name),
            page: 30, width: 1259, height: 905,
            gridType: 'gridless',
            imageLeft: 0, imageRight: 1000, imageCols: 10,
            imageTop: 0, imageBottom: 1000, imageRows: 10,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map7',
            nameInfo: { x: 76, y: 694.9183 },
            nameFn: name => sentenceCase(name),
            page: 35, width: 441, height: 405,
            imageLeft: 10, imageRight: 426, imageCols: 20,
            imageTop: 12, imageBottom: 387, imageRows: 18,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map8',
            nameInfo: { x: 74, y: 227.7932 },
            nameFn: name => sentenceCase(name),
            page: 37, width: 910, height: 356,
            imageLeft: 14, imageRight: 897, imageCols: 42,
            imageTop: 20, imageBottom: 336, imageRows: 15,
            globalLight: true,
        }),

        new ModuleScene({
            name: 'map9',
            nameInfo: { x: 303.25, y: 250.9183 },
            nameFn: name => sentenceCase(name),
            page: 39, width: 441, height: 405,
            imageLeft: 16, imageRight: 432, imageCols: 20,
            imageTop: 11, imageBottom: 386, imageRows: 18,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map10',
            nameInfo: { x: 76, y: 694.9183 },
            nameFn: name => sentenceCase(name),
            page: 41, width: 441, height: 405,
            imageLeft: 9, imageRight: 430, imageCols: 19,
            imageTop: 18, imageBottom: 394, imageRows: 17,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map11',
            nameInfo: { x: 334.75, y: 694.9183 },
            nameFn: name => sentenceCase(name),
            page: 46, width: 441, height: 405,
            imageLeft: 9, imageRight: 430, imageCols: 19,
            imageTop: 20, imageBottom: 398, imageRows: 17,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map12',
            nameInfo: { x: 85, y: 317.2502 },
            nameFn: name => sentenceCase(name),
            page: 50, width: 622, height: 631,
            imageLeft: 62, imageRight: 566, imageCols: 48,
            imageTop: 79, imageBottom: 574, imageRows: 47,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map13',
            nameInfo: { x: 301, y: 91.3362 },
            nameFn: name => sentenceCase(name),
            page: 55, width: 478, height: 498,
            imageLeft: 29, imageRight: 442, imageCols: 37,
            imageTop: 40, imageBottom: 466, imageRows: 38,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map14',
            nameInfo: { x: 298, y: 591 },
            nameFn: name => sentenceCase(name),
            page: 58, width: 297, height: 296,
            imageLeft: 34, imageRight: 264, imageCols: 14,
            imageTop: 32, imageBottom: 263, imageRows: 14,
            globalLight: true,
        }),
        new ModuleScene({
            name: 'map15',
            nameInfo: { x: 39, y: 753 },
            nameFn: name => sentenceCase(name),
            page: 62, width: 1261, height: 905,
            gridType: 'gridless',
            imageLeft: 0, imageRight: 1000, imageCols: 10,
            imageTop: 0, imageBottom: 1000, imageRows: 10,
            globalLight: true,
        }),
    ],
    journals: [
        new AdventureImage({ name: 'journal1', page: 2, width: 589, height: 809, index: 0 }),
        new AdventureImage({ name: 'journal2', page: 2, width: 589, height: 809, index: 1 }),
        new AdventureImage({ name: 'journal3', page: 2, width: 589, height: 809, index: 2 }),
        new AdventureImage({ name: 'journal4', page: 2, width: 589, height: 809, index: 3 }),
        new AdventureImage({ name: 'journal5', page: 2, width: 589, height: 809, index: 4 }),
        new AdventureImage({ name: 'journal6', page: 2, width: 589, height: 809, index: 5 }),
        new AdventureImage({ name: 'journal1', page: 4, width: 1261, height: 1636 }),
        new AdventureImage({ name: 'journal1', page: 6, width: 1259, height: 805 }),
        new AdventureImage({ name: 'journal1', page: 28, width: 1259, height: 805 }),
        new AdventureImage({ name: 'journal1', page: 48, width: 1259, height: 805 }),
        new AdventureImage({ name: 'journal1', page: 60, width: 1260, height: 1636 }),
        new AdventureImage({ name: 'journal1', page: 66, width: 1261, height: 1636 }),
        new AdventureImage({ name: 'journal1', page: 68, width: 570, height: 570 }),
        new AdventureImage({ name: 'journal1', page: 69, width: 601, height: 601 }),
        new AdventureImage({ name: 'journal1', page: 70, width: 600, height: 763 }),
        new AdventureImage({ name: 'journal1', page: 71, width: 564, height: 564, index: 1 }),
        new AdventureImage({ name: 'journal1', page: 72, width: 1261, height: 1636 }),
        new AdventureImage({ name: 'journal1', page: 76, width: 534, height: 534 }),
        new AdventureImage({ name: 'journal1', page: 77, width: 558, height: 558, index: 1 }),

        new CaptionImage({ name: 'npc1', page: 7, width: 479, height: 515 }),
        new CaptionImage({ name: 'npc1', page: 10, width: 511, height: 549 }),
        new CaptionImage({ name: 'npc1', page: 14, width: 818, height: 1279 }),
        new CaptionImage({ name: 'npc1', page: 15, width: 743, height: 1081 }),
        new CaptionImage({ name: 'npc1', page: 16, width: 780, height: 1270 }),
        new CaptionImage({ name: 'npc1', page: 18, width: 830, height: 778 }),
        new CaptionImage({ name: 'npc1', page: 19, width: 510, height: 555 }),
        new CaptionImage({ name: 'npc1', page: 20, width: 510, height: 553 }),
        new CaptionImage({ name: 'npc1', page: 23, width: 1009, height: 1238 }),
        new CaptionImage({ name: 'npc1', page: 24, width: 510, height: 553 }),
        new CaptionImage({ name: 'npc1', page: 25, width: 1075, height: 1076 }),
        new CaptionImage({ name: 'npc1', page: 27, width: 911, height: 1222 }),
        new CaptionImage({ name: 'npc1', page: 31, width: 801, height: 1182 }),
        new CaptionImage({ name: 'npc1', page: 32, width: 439, height: 594 }),
        new CaptionImage({ name: 'npc1', page: 33, width: 797, height: 936 }),
        new CaptionImage({ name: 'npc1', page: 34, width: 853, height: 937 }),
        new CaptionImage({ name: 'npc1', page: 35, width: 876, height: 1246 }),
        new CaptionImage({ name: 'npc1', page: 36, width: 897, height: 1338 }),
        new CaptionImage({ name: 'npc1', page: 38, width: 905, height: 1317 }),
        new CaptionImage({ name: 'npc1', page: 40, width: 864, height: 1182 }),
        new CaptionImage({ name: 'npc1', page: 41, width: 990, height: 1014 }),
        new CaptionImage({ name: 'npc1', page: 42, width: 836, height: 1234 }),
        new CaptionImage({ name: 'npc1', page: 43, width: 734, height: 1198 }),
        new CaptionImage({ name: 'npc1', page: 44, width: 867, height: 1095 }),
        new CaptionImage({ name: 'npc1', page: 46, width: 843, height: 1168 }),
        new CaptionImage({ name: 'npc1', page: 47, width: 923, height: 1346 }),
        new CaptionImage({ name: 'npc1', page: 52, width: 868, height: 1171 }),
        new CaptionImage({ name: 'npc1', page: 54, width: 528, height: 610 }),
        new CaptionImage({ name: 'npc1', page: 56, width: 918, height: 1370 }),
        new CaptionImage({ name: 'npc1', page: 57, width: 879, height: 1126 }),
        new CaptionImage({ name: 'npc1', page: 59, width: 515, height: 504 }),
        new CaptionImage({ name: 'npc1', page: 65, width: 803, height: 934 }),
        new CaptionImage({ name: 'npc1', page: 75, width: 780, height: 1061 }),
        new CaptionImage({ name: 'npc1', page: 79, width: 930, height: 1356 }),
        new CaptionImage({ name: 'npc1', page: 80, width: 901, height: 1023 }),
        new CaptionImage({ name: 'npc1', page: 81, width: 1126, height: 1170 }),
        new CaptionImage({ name: 'npc1', page: 82, width: 1205, height: 1125 }),
        new CaptionImage({ name: 'npc1', page: 83, width: 861, height: 1075 }),
        new CaptionImage({ name: 'npc1', page: 84, width: 742, height: 1120 }),
        new CaptionImage({ name: 'npc1', page: 85, width: 805, height: 1294 }),
        new CaptionImage({ name: 'npc1', page: 86, width: 960, height: 888 }),
        new CaptionImage({ name: 'npc1', page: 87, width: 842, height: 1115 }),
        new CaptionImage({ name: 'npc1', page: 89, width: 916, height: 1221 }),
        new CaptionImage({ name: 'npc1', page: 91, width: 851, height: 1261 }),
        new CaptionImage({ name: 'npc1', page: 93, width: 926, height: 1267 }),
    ],
    finalize: (moduleData: ModuleData) => {
    }
};

export default adventureModule;